import contextlib
import datetime
import re
import urllib

url = 'https://www.google.com/finance/historical?cid=983582&startdate=Jan%202%2C%201970&num=200&start='
start = 0
with open("DJI.csv", 'w') as outfile:
    outfile.write('Date,Open,High,Low,Close,Volume\n')
    while True:
        with contextlib.closing(urllib.urlopen(url+str(start))) as page:
            html = page.read()
        tds = re.findall(r'<td class="lm">(.+)\n<td class="rgt">(.+)\n'
                         r'<td class="rgt">(.+)\n<td class="rgt">(.+)\n'
                         r'<td class="rgt">(.+)\n<td class="rgt rm">(.+)\n',
                         html)
        if tds:
            for td in tds:
                line = ','.join([datetime.datetime.strptime(td[0], '%b %d, %Y').strftime('%Y/%m/%d')] +
                                map(lambda s: s.replace(',', ''), td[1:]))
                outfile.write(line+'\n')
            if line.startswith('1970/01/02'):
                break
        start += 200